What happens?
----------------

Check the automated [**log**](script.log) file after upload. The PHP script does not save the files but logs every request.

Check the Firebug console for event debugging logs. *Filesize is limited to 2Mb (client- and serverside).*

### Do Not:

 * ... copy this example and ask why it doesn't upload the files. It only logs the uploaded images!
 * ... copy this example without changing the XHTML, the CSS or the images!
 * ... skip all validation on the server and blindly move the files!
 
### Please Do:

 * ... take this showcase as a code example about processing and validating the uploaded file and create your own server code.
 * ... adapt the XHTML, the CSS and the images to your needs.
 * ... edit the provided [source](https://github.com/digitarald/digitarald-fancyupload) to fit your needs and [submit patches](/contact/) to the author